%% Exercice Softmax M2 IM 
%  Instructions
%  ------------
% 
%  Ce fichier contient les commandes principales de l'exercice. Il n'est pas a modifier. 
%  Vous devez implementer :
%
%     sigmoid.m
%     logisticCost.m
%     logisticPredict.m
%
%% Initialisation
clear ; close all; clc

%% Chargement des donnees
%  Les deux premieres colonnes contiennent les notes aux examens et la troisieme 
%  contient le label.

data = load('exoLogisticData2D.txt');
X = data(:, [1, 2]); y = data(:, 3);

%% ==================== Partie 1: Plot ====================
%  Afficher les donnees pour comprendre le probleme

fprintf(['Graphe des donnees avec + pour (y = 1) et o ' ...
         'pour (y = 0).\n']);

plotDataLogistic(X, y);

hold on;
xlabel('Note Examen 1')
ylabel('Note Examen 2')

% Specified in plot order
legend('Admis', 'Pas admis')
hold off;

fprintf('\nPause. Appuyez sur entree pour continuer.\n');
pause;


%% ============ Partie 2: Calculez le cout et le gradient ============
%  Dans cette partie de l'exercise, vous allez implementer le cout et le gradient
%  pour la regression logistique en completant le code de  
%  logisticCost.m

%  Setup the data matrix appropriately, and add ones for the intercept term
[m, n] = size(X);

% Add intercept term to x and X_test
X = [ones(m, 1) X];

% Initialize fitting parameters
initial_theta = zeros(n + 1, 1);

% Compute and display initial cost and gradient
[cost, grad] = logisticCost(initial_theta, X, y);

fprintf('Cout avec theta initial (zeros): %f\n', cost);
fprintf('Gradient initial avec theta (zeros): \n');
fprintf(' %f \n', grad);

fprintf('\nPause. Appuyez sur entree pour continuer.\n');
pause;


%% ============= Part 3: Optimisation avec fminunc  =============
%  Dans cet exercice, vous allez utiliser une fonction built-in (fminunc)
%  pour trouver les parametes theta optimaux

%  Reglez les options de fminunc
options = optimset('GradObj', 'on', 'MaxIter', 400);

%  Executez fminunc pour obtenir theta
%  Cette fonction retourne theta et le cout 
[theta, cost] = ...
	fminunc(@(t)(logisticCost(t, X, y)), initial_theta, options);

% Affichez theta 
fprintf('Cout avec theta trouve par fminunc: %f\n', cost);
fprintf('theta: \n');
fprintf(' %f \n', theta);

% Affichez la frontiere de decision
plotDecisionBoundaryLogistic(theta, X, y);

hold on;
xlabel('Note Examen 1')
ylabel('Note Examen 2')

legend('Admis', 'Pas admis')
hold off;

fprintf('\nPause. Appuyez sur entree pour continuer.\n');
pause;

%% ============== Partie 4: Predictions et Performance ==============
%  Apres apprentissage des parametres, on peut les utiliser pour faire des
%  predictions sur de nouvelles donnees. Dans cette partie, on considere un 
%  etudiant qui a une note de 45 a l'examen 1 et 85 a l'examen 2.
%
%  Vous devez completer le code de logisticPredict.m

%  Prediction pour l'etudiant

prob = sigmoid([1 45 85] * theta);
fprintf(['Pour un etudiant avec des notes de 45 et 85, on predit une probabilite d''admission ' ...
         'de %f\n\n'], prob);

% Calculez la performance globale sur le corpus d'apprentissage :
p = logisticPredict(theta, X)
% tmp = 0:1:length(p);
% tmp(p)

fprintf('Performance sur Train : %f\n', mean(double(p == y)) * 100);

fprintf('\nPause. Appuyez sur entree pour continuer.\n');
pause;

